
# <img src="man/figures/logo.svg" align="right" height="139" /> R package pomdpSolve - Interface to ‘pomdp-solve’ for Partially Observable Markov Decision Processes

[![CRAN
version](http://www.r-pkg.org/badges/version/pomdpSolve)](https://CRAN.R-project.org/package=pomdpSolve)
[![stream r-universe
status](https://mhahsler.r-universe.dev/badges/pomdpSolve)](https://mhahsler.r-universe.dev/ui#package:pomdpSolve)
[![CRAN RStudio mirror
downloads](http://cranlogs.r-pkg.org/badges/pomdpSolve)](https://CRAN.R-project.org/package=pomdpSolve)

Provides [pomdp-solve](http://www.pomdp.org/code/) (Cassandra, 2015) to
solve POMDPs using a variety of algorithms. A convenient interface is
provided in package [pomdp](https://github.com/mhahsler/pomdp).

## Installation

**Stable CRAN version:** Install from within R with

``` r
install.packages("pomdpSolve")
```

**Current development version:** Install from
[r-universe.](https://mhahsler.r-universe.dev/ui#package:pomdpSolve)

``` r
install.packages("pomdpSolve", repos = "https://mhahsler.r-universe.dev")
```

## How to Cite this Package

To cite package ‘pomdpSolve’ in publications use:

Hahsler M, Cassandra AR (2022). *pomdpSolve: Interface to ‘pomdp-solve’
for Partially Observable Markov Decision Processes*. R package version
1.0.1, <https://github.com/mhahsler/pomdpSolve>.

A BibTeX entry for LaTeX users is

@Manual{, title = {pomdpSolve: Interface to ‘pomdp-solve’ for Partially
Observable Markov Decision Processes}, author = {Michael Hahsler and
Anthony R. Cassandra}, year = {2022}, note = {R package version 1.0.1},
url = {<https://github.com/mhahsler/pomdpSolve>}, }

## References

-   Cassandra, A. (2015). pomdp-solve: POMDP Solver Software,
    <http://www.pomdp.org>.
